#include <bits/stdc++.h>
using namespace std;

long int ucln(long int a, long int b)
{
      while (a!=b)
    {if (a>b)
        {
            a=a-b;
        }
        else b=b-a;
    }
    return a;
}
long long bcnn(long long a,long long b)
{
    return (a*b)/ucln(a,b);
}
int main()
{
   ifstream f1("UCBC.inp");
   ofstream f2("UCBC.out");
   long long n;
   long long d,D;
   f1>>n;
   long int a[10000];
   for(long long i=0;i<n;i++)
   {
       f1>>a[i];
   }
   d=ucln(a[0],a[1]);
   D=bcnn(a[0],a[1]);
   for(long long i=2;i<n;i++)
   {
       d=ucln(d,a[i]);
       D=bcnn(D,a[i]);
   }
   f2<<d<<endl<<D;
   f1.close();
   f2.close();
   return 0;
}
